#!/bin/bash

# Check if all parameters are present
# If no, exit
if [ $# -ne 1 ] && [ $# -ne 2 ]
then
        echo "usage :"
        echo "`basename $0` USERNAME [ZEFILE]"
        exit 0
fi

USERNAME=$1
ZEFILE=$2

#create sudoers.locked
sed "/# User alias specification/a\User_Alias     PARTIALADMINS = $USERNAME" yourpath/sudoers.locked.template >yourpath/sudoers.locked

#check sudoers.locked
if ! ( visudo -c -f yourpath/sudoers.locked )
then
    echo "ERROR: sudoers.locked was not parsed successfully."
    exit 1
fi

#locked groups
echo "-->locking groups"
yourpath/remove_user_from_group.sh $USERNAME gamer
yourpath/remove_user_from_group.sh $USERNAME programmer
yourpath/remove_user_from_group.sh $USERNAME browsers

#backup files
echo "-->making backups"
cp -v /etc/sudoers sudoers.$(date +%Y%m%d_%H%M%S)
cp -v /boot/grub/menu.lst menu.lst.$(date +%Y%m%d_%H%M%S)

#replace files
echo "-->Locking system"
#cp -v menu.lst.locked /boot/grub/menu.lst
sed -i s/^#password/password/ /boot/grub/menu.lst
cp -v sudoers.locked /etc/sudoers

if [ ! -z $ZEFILE ]
then
    if [ ! -s $ZEFILE ]
    then
	echo "ERROR: $ZEFILE does not exist or is empty."
	exit 1
    fi
    echo "adding $ZEFILE unlocking to crontab"
    sed "\$a\* * 1 * * chmod 755 $ZEFILE" yourpath/crontab.locked.template >yourpath/crontab.locked
    echo "chmod 000 $ZEFILE"
    chmod 000 $ZEFILE
else
    cp -v yourpath/crontab.locked.template yourpath/crontab.locked
fi
echo "================"
cat yourpath/crontab.locked.template
echo "================"
cat yourpath/crontab.locked
echo "================"

echo "activating time lock"
crontab yourpath/crontab.locked

echo "Would you like to change the root password?"
read ans
case $ans in
        y|Y|yes) passwd root;;
esac

echo "System lockdown successful."
